#include <bits/stdc++.h>
#define fi first
#define sc second
#define all(x) x.begin(), x.end()
#define vi vector<int>
#define pii pair<int,int>
using namespace std;
typedef long long ll;

#define int long long
signed main()
{
    ios_base::sync_with_stdio(0); cin.tie(0);
    int n, k; cin >> n >> k;
    vi a(k);
    for(int i = 0; i < k; i++) cin >> a[i];
    //sort(all(a));
    if(n <= 1000){
        for(int i = 0; i < k; i++){
            int ans = 0;
            for(int j = 1; j*j <= a[i]; j++){
                if(a[i]%j==0){
                    ans ^= j;
                    if(j != a[i]/j) ans ^= a[i]/j;
                }
            }
            cout << ans << ' ';
        }
        cout << '\n';
    }
    else cout << ":)\n";
    return 0;
}